#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 100000;
const int MMAX = 1000000;
const int QMAX = 1000000;

int main(int argc, char** argv) {
  registerValidation(argc, argv);
  int t = inf.readInt(1, 2, "t");
  inf.readEoln();
  int n = inf.readInt(1, NMAX, "n");
  inf.readSpace();
  int m = inf.readInt(1, MMAX, "m");
  inf.readSpace();
  int q = inf.readInt(1, QMAX, "q");
  inf.readEoln();

  set<pair<int, int> > edges;
  for(int i = 1;i <= m;i++){
    int x = inf.readInt(1, n, "x_i");
    inf.readSpace();
    int y = inf.readInt(1, n, "y_i");
    inf.readEoln();
    inf.ensuref(x != y, "x_i should e different from y_i");
    inf.ensuref(edges.count({x, y}) == 0, "no multiple edges are allowed");
    edges.insert({x, y});
  }
  inf.readEof();

  return 0;
}

